#include <iostream>
#include <string>
using namespace std;
#include "escapi.h"
#include <stdio.h>
#include <cstdlib>
#include <fstream>
#include <SFML/Graphics.hpp>
bool capture(std::string filename, unsigned int device);

int width;
int height;

int main(int argc, char** argv)
{
    width = 320;
    height = 240;
    if(argc > 2)
    {
        int device;
        device = atoi(argv[2]);
        if(argc > 4)
        {
            width = atoi(argv[3]);
            height = atoi(argv[4]);
            cout << "Args: " << argv[1] << " - " << argv[2] << " - " << argv[3] << " - " << argv[4] << endl;
        }
        else
            cout << "Args: " << argv[1] << " - " << argv[2] << endl;
        capture(argv[1], device);
        return 0;
    }
    else
    {
        cout << "Wrong Input!" << endl;
        cout << "USAGE:" << endl;
        cout << "   ****.exe <filename> <device> [width] [height]" << endl;
        cout << "If you don't know what device you need, then just enter 0" << endl;
        int devices = setupESCAPI();
        cout << "DEVICE-COUNT:" << endl;
        cout << "   " << devices << endl;
    }

        return EXIT_FAILURE;
}

bool capture(std::string filename, unsigned int device)
{
  /* Initialize ESCAPI */

  int devices = setupESCAPI();


  if (devices == 0)
  {
    printf("ESCAPI initialization failure or no devices found.\n");
    return false;
  }

  /* Set up capture parameters.
   * ESCAPI will scale the data received from the camera
   * (with point sampling) to whatever values you want.
   * Typically the native resolution is 320*240.
   */

  struct SimpleCapParams capture;
  capture.mWidth = width;
  capture.mHeight = height;
  capture.mTargetBuf = new int[width * height];

  /* Initialize capture - only one capture may be active per device,
   * but several devices may be captured at the same time.
   *
   * 0 is the first device.
   */

  if (initCapture(0, &capture) == 0)
  {
    printf("Capture failed - device may already be in use.\n");
    return false;
  }

  /* request a capture */
  unsigned int i = 0;
  while (i < 10)
  {
    doCapture(0);
    while (isCaptureDone(0) == 0)
    {

    }
    i++;
  }

  /* now we have the data in capture.mTargetBuf
   * If we want another frame, we'll just call doCapture(0) again.
   * When done, we'll shut down:
   */
    unsigned x = 0, y = 0;

    sf::Image image;
    image.create(width, height, sf::Color::Black);
    for(i = 0; i < width * height; i++)
    {
        unsigned char bytes[3];
        bytes[0] = (capture.mTargetBuf[i] >> 16) & 0xFF;
        bytes[1] = (capture.mTargetBuf[i] >> 8) & 0xFF;
        bytes[2] = capture.mTargetBuf[i] & 0xFF;
        image.setPixel(x, y, sf::Color((int) bytes[0], (int) bytes[1], (int) bytes[2], 255));
        if(x == width)
        {
            x = 0;
            y++;
        }
        x++;
    }
    image.saveToFile(filename);
  deinitCapture(device);
  return true;
}
